"""
Author: Lukas Runt
Email: lrunt@students.zcu.cz
Date: November 04, 2023
Version: 1.0.0
Description: Knowledge base, this module contains all rules what expert system uses
"""

"""
Required luminosity in lux by ČSN norm
"""
required_lux = {
    "Kuchyně": 300,
    "Obývací pokoj": 300,
    "Ložnice": 300,
    "Dětský pokoj": 300,
    "Koupelna": 200,
    "Záchod": 200,
    "Chodba": 100,
    "Sklep": 50,
    "Garáž": 75,
    "Dílna": 150,
    "Pracovna": 300,
    "Schodiště": 150
}

"""
Rule which type of light the room needs
"""
recommended_colors = {
    "Kuchyně": "NEUTRAL",
    "Obývací pokoj": "WARM",
    "Ložnice": "WARM",
    "Dětský pokoj": "WARM",
    "Koupelna": "NEUTRAL",
    "Záchod": "NEUTRAL",
    "Chodba": "NEUTRAL",
    "Sklep": "COLD",
    "Garáž": "COLD",
    "Dílna": "COLD",
    "Pracovna": "COLD",
    "Schodiště": "NEUTRAL"
}

"""
Colors intervals in Kelvins
"""
colors = {
    "WARM": [1900, 3999],
    "NEUTRAL": [4000, 6499],
    "COLD": [6500, 9000]
}

"""
If room can have some special lights
"""
special_option = {
    "Kuchyně": ["LINKA"],
    "Obývací pokoj": ["DECORATION"],
    "Ložnice": ["LAMP", "DECORATION"],
    "Dětský pokoj": ["LAMP", "DECORATION"],
    "Koupelna": [],
    "Záchod": [],
    "Chodba": [],
    "Sklep": [],
    "Garáž": [],
    "Dílna": ["LAMP"],
    "Pracovna": ["LAMP"],
    "Schodiště": []
}

"""
Which group the light belongs to 
"""
speciality_of_type = {
    "Žárovka": "BASIC",
    "Stropní světlo": "BASIC",
    "Bodové světlo": "BASIC",
    "Stolní lampa": "LAMP",
    "Dekorativní světla": "DECORATION",
    "Kuchyňská linka": "LINKA"
}
