"""
Author: Lukas Runt
Email: lrunt@students.zcu.cz
Date: November 04, 2023
Version: 1.0.0
Description: Explanation module of expert system, printing result to the user and explaining it
"""
import KomunikacniModul


def print_options(array):
    """
    Method prints possible options to the user
    :param array: array what will be printed as option
    """
    for i in range(len(array)):
        print(f"{(i + 1):2}: {array[i]}")


def print_result(lights, rooms, required_lumen, recommended_colors):
    """
    Method prints result of expert system
    :param lights: chosen lights
    :param rooms: rooms entered by user
    :param required_lumen: are lumen required to each room
    :param recommended_colors: are colors what are recommended to each room
    """
    for i in range(len(rooms)):
        print(KomunikacniModul.separator)
        print(KomunikacniModul.print_room_result(rooms[i]), end="")
        for key, value in lights[i].items():
            if key == 'BASIC':
                print(KomunikacniModul.print_basic_lights(value, required_lumen[i], recommended_colors[i], rooms[i]), end="")
            else:
                print(KomunikacniModul.print_special_lights(value, key), end="")
