"""
Autor: Matěj Vohradský (vohry8@students.zcu.cz)
Datum: 2023-11-01
Program: Inferencni mechanismus
Verze: 1.0.0
"""

# komunikacni modul
import komunikacni_modul as km
# baze dat
import baze_dat as bd
# baze znalosti
import baze_znalosti as bz
# generator vysledku
import generator_vysledku as gv


# hlavni metoda programu
def spustit():
    # vypise uvodni text
    km.vypis_uvod()
    # projde vsechny pokoje
    for pokoj in bd.pokoje:
        # zepta se na pocet daneho typu pokoje
        pocet_pokoju = km.pocet_pokoju(pokoj)
        # pokud pocet mensi nez rovno 0 pokracuje na dalsi pokoj
        if pocet_pokoju == 0:
            # vykresli caru mezi pokoji
            km.cara()
        # bude se ptat dokud nedojdou pokoje daneho typu
        while pocet_pokoju > 0:
            pocet_LED = 0
            pocet_zarovek = 0
            pocet_zarivek = 0
            odpoved = 1
            # bude se ptat dokud nedostane odpoved ze ma prestat
            while odpoved:
                # zepta se na pozadovanou vlastnost svitidla
                vlastnost = km.vlastnost_svitidla(pokoj)
                # zepta se na pocet svitidel s danou vlastnosti
                pocet_svitidel = km.pocet_svitidel()
                # vybere svitidlo
                svitidlo = bz.vyber_svitidlo(pokoj, vlastnost)
                # podle vybraneho svitidla pripocte jejich pocet k udaji
                if svitidlo == 0:
                    pocet_LED += pocet_svitidel
                elif svitidlo == 1:
                    pocet_zarovek += pocet_svitidel
                else:
                    pocet_zarivek += pocet_svitidel
                # zepta se jestli ma pokracovat ve vyberu svitidel
                odpoved = km.pokracovat()
            # vykresli caru mezi pokoji
            km.cara()
            # prida udaj do generatoru vysledku
            gv.pridej_udaj(pocet_LED, pocet_zarovek, pocet_zarivek, pokoj)
            pocet_pokoju -= 1
    # zpracuje a odesle vysledek do komunikacniho modulu
    gv.odesli_vysledek()
