# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 28. 10. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi k ukladani jednotlivych dat bez toho, abychom
# o techto datech meli nejake sirsi znalosti.
# ------------------------------------------------------------------------------------------------

# Trida Svetlo umoznuje vytvaret instance jednotlivych svitidel.
class Svetlo:
    # svetelny tok je stanoven v lumenech
    # teplota osvetleni je v kelvinech, pokud je predano pole, prvni prvek je minimum a druhy maximum
    # paradoxne, cim vice kelvinu, tim mene je barva tepla
    # naklady jsou vyjadreny relativne vuci klasicke zarovce (priblizne)
    # zivotnost je v hodinach
    # zajimavost vzhledu je z intervalu <0, 1> (je subjektivni)
    def __init__(self, nazev, svetelny_tok, teplota_osvetleni, cena, naklady, zivotnost,
                 zajimavost_vzhledu, moznost_menit_barvu):
        self.nazev = nazev
        self.svetelny_tok = svetelny_tok
        self.teplota_osvetleni = teplota_osvetleni
        self.cena = cena
        self.naklady = naklady
        self.zivotnost = zivotnost
        self.zajimavost_vzhledu = zajimavost_vzhledu
        self.moznost_menit_barvu = moznost_menit_barvu


# Tato trida reprezentuje konkretni mistnost.
class Mistnost:
    def __init__(self, nazev_mistnosti):
        self.nazev = nazev_mistnosti


svetla = [
    Svetlo("zarovka", 1050, 3000, 36, 1, 1000, 0.1, False),
    Svetlo("LED zarovka", 2090, 4000, 69, 0.15, 25000, 0.12, False),
    Svetlo("chytra zarovka", 800, [2500, 6500], 287, 0.05, 15000, 0.8, True)
]

mistnosti = [
    Mistnost("obyvaci pokoj"),
    Mistnost("loznice"),
    Mistnost("pokoj"),
    Mistnost("kuchyne"),
    Mistnost("chodba"),
    Mistnost("toaleta"),
    Mistnost("koupelna"),
    Mistnost("garaz"),
    Mistnost("kotelna")
]


# Vezme si jako parametr nazev svitidla a vrati jeho cenu,
# pokud takove svitidlo neexistuje, vrati 0.
def ziskej_cenu_svetla(svetlo):
    for s in svetla:
        if s.nazev == svetlo:
            return s.cena
    return 0

# nektere z pouzitych zdroju:
# https://www.usetreno.cz/clanky/jak-snizit-naklady-na-sviceni/
# https://www.emos.cz/jak-vybrat-spravne-osvetleni-do-kazde-mistnosti
# https://zarovky.heureka.cz/berge-led-zarovka-ecoplanet-e27-12w-1050lm-tepla-bila/#specifikace/
# https://zarovky.heureka.cz/solight-led-zarovka-klasicky-tvar-22w-e27_4000k-270-2090lm-wz536/#prehled/
# https://zarovky.heureka.cz/tp-link-tapo-l530e-smart-zarovka-e27_8-7-w-vicebarevna-rgb-1-ks/#specifikace/
