# Autor: Lukas Sobotka
# Datum: 6. 11. 2023
# Verze: 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi k ukladani jednotlivych dat
# ------------------------------------------------------------------------------------------------


# Trida predstavuje jednotliva svitidla
class Svetlo:

    # Hodnoty jednotlivych atributu jsou na stupnici od 1 do 5 krome pohodlnosti
    # cena - cena svetla v korunach prevedena na stupnici 1 az 5
    # uspornost - pomer vykon/svetelny tok preveden na stupnici 1 az 5
    # zivotnost - zivotnost prevedena na stupnici 1 az 5
    # pohodlnost - luxus patrici k danemu druhu svitidla, stupnice 1 az 8
    def __init__(self, cena, uspornost, zivotnost, pohodlnost):
        self.cena = cena
        self.uspornost = uspornost
        self.zivotnost = zivotnost
        self.pohodlnost = pohodlnost

    # Porovna instanci teto tridy s jinou instanci teto tridy a vrati vzdalenost
    def porovnej(self, druhe):
        vysledek = abs(self.uspornost - druhe.uspornost)
        vysledek += abs(self.pohodlnost - druhe.pohodlnost)

        if self.cena == 1 or druhe.cena == 1:
            vysledek += abs(self.cena - druhe.cena)

        if self.zivotnost == 1 or druhe.zivotnost == 1:
            vysledek += abs(self.zivotnost - druhe.zivotnost)

        return vysledek


# seznam vsech moznych typu mistnosti
mistnosti = ["Koupelna", "Kuchyn", "Obyvaci pokoj", "Loznice", "Chodba", "Garaz"]

# seznam realnych cen svitidel
ceny_svetel = {"Zarovka": 40, "LED Zarovka": 70, "Zarivka": 60, "Chytra zarovka": 280}

# seznam svitidel
svetla = {"Zarovka": Svetlo(1, 5, 5, 4),
          "LED Zarovka": Svetlo(2, 1, 1, 6),
          "Zarivka": Svetlo(2, 2, 3, 1),
          "Chytra zarovka": Svetlo(5, 2, 1, 8)}
