# Autor: Lukas Sobotka
# Datum: 6. 11. 2023
# Verze: 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi pro rizeni celeho projektu a usuzovani jaka svetla udou vybrana na zaklade preferenci
# ------------------------------------------------------------------------------------------------
import sys

import baze_znalosti
import baze_dat
import komunikacni_modul


# Preference mistnosti doplni o preference uzivatele
# preferovane - svitidlo preferovane mistnosti
# preference - pole uzivatelskych preferenci
def dopln_preference(preferovane, preference):
    if "1" in preference:
        preferovane.cena = 1
    if "2" in preference:
        preferovane.uspornost = 1
    if "3" in preference:
        preferovane.zivotnost = 1


# Pro danou mistnost vybere svetlo s ohledem na uzivatelske preference
# mistnost - typ mistnosti
# preference - pole uzivatelskych preferenci
# return - vybrane svetlo
def vyber_svetlo(mistnost, preference):
    if "4" in preference:
        return "Chytra zarovka"
    pref_mistnosti = baze_znalosti.preference_podle_mistnosti.get(mistnost)
    preferovane = baze_dat.Svetlo(pref_mistnosti[0], pref_mistnosti[1], pref_mistnosti[2], pref_mistnosti[3])
    dopln_preference(preferovane, preference)
    nejlepsi_skore = sys.maxsize
    nejlepsi = None
    for nazev, svetlo in baze_dat.svetla.items():
        if svetlo.porovnej(preferovane) < nejlepsi_skore:
            nejlepsi = nazev
            nejlepsi_skore = svetlo.porovnej(preferovane)
    return nejlepsi


# hlavni funkce programu
def start():
    komunikacni_modul.vypis_uvod()
    vybrana_svetla = []

    for mistnost in baze_dat.mistnosti:
        pocet = komunikacni_modul.pocet_mistnosti(mistnost)
        for i in range(0, pocet):
            preference = komunikacni_modul.ziskej_preference(mistnost, i)
            svetlo = vyber_svetlo(mistnost, preference)
            vybrana_svetla.append(mistnost + "-" + str(i) + "-" + svetlo)

    komunikacni_modul.vypis_vyledek(vybrana_svetla, baze_dat.ceny_svetel)
