# Autor: Lukas Sobotka
# Datum: 6. 11. 2023
# Verze: 1.0
# ------------------------------------------------------------------------------------------------
# Tento modul slouzi pro komunikaci s uzivatelem
# ------------------------------------------------------------------------------------------------

# Vypise uvodni zpravu informujici o programu
def vypis_uvod():
    print("Autor: Lukas Sobotka\nProgram: Navrh osvetleni domacnosti\n"
          "Vitejte, tento program slouzi k navrhu koupe osvetleni podle vami zadanych pozadavku.\n"
          "Pouziti je snadne staci podle svych preferenci odpovidat na otazky a "
          "program vam na konci vypise navrzene osvetleni\n"
          "Svoje odpovedi potvrdite stisknutim klavesy ENTER\n")


# Zepta se uzivatele na pocet mistnosti daneho typu
# mistnost  - nazev mistnosti, na kterou se ptame
# return - pocet zadany uzivatelem
def pocet_mistnosti(mistnost):
    vstup = input("Kolik mate v domacnosti mistnosti typu " + mistnost + "? ")
    # Pri zadani spatneho vstupu se ptame porad dokola
    while not vstup.isdigit():
        vstup = input("Zadana spatna hodnota, kolik mate v domacnosti mistnosti typu " + mistnost + "? ")
    return int(vstup)


# Zepta se uzivatele na vyber preferovane vlastnosti pro svetlo
# mistnost - Typ mistnosti, ktere se otazka tyka
# cislo - cislo mistnosti
# return - seznam uzivatelem zadanych cisel
def ziskej_preference(mistnost, cislo):
    print("-------------------------------------------------------------------------------------------")
    print(
        "Pokud chcete muzete specifikovat preferovane vlastnosti pro svitidlo do mistnosti " + mistnost + " c. " + str(
            cislo + 1))
    print("1) Nizka porizovaci cena")
    print("2) Energeticky usporne")
    print("3) Dlouha zivotnost")
    print("4) Moznost zmeneni barvy\n")
    vstup = input("Napiste cisla odpovidajici vasim specifikacim oddelena mezernikem: ")

    # pri nezadani vstupu je vraceno prazdne pole
    if vstup is None:
        return []

    # pri zadani spatneho vstupu se dotaz zopakuje
    while True:
        spravne_zadano = True
        vlastnosti = vstup.split()
        for cislo in vlastnosti:
            if not cislo.isdigit() or int(cislo) < 1 or int(cislo) > 4:
                spravne_zadano = False
                break
        if spravne_zadano:
            break
        vstup = input("Nebyly spravne zvoleny vlastnosti zadejte cisla od 1 do 4 oddelena mezerami: ")
    return vstup.split()


# Vypise vybrana svetla pro kazdou mistnost a jejich ceny
# vybrana_svetla - jaka svetla byla vybrana a pro jake mistnosti
# ceny_svetel - tabulka realnych cen svetel
def vypis_vyledek(vybrana_svetla, ceny_svetel):
    cena = 0
    for mistnost in vybrana_svetla:
        typ_mistnosti = mistnost.split("-")[0]
        cislo = int(mistnost.split("-")[1]) + 1
        svetlo = mistnost.split("-")[2]
        opt = ""
        if cislo > 1:
            opt = " c. " + str(cislo)
        print("Pro mistnost " + typ_mistnosti + opt + " bylo vybrano osvetleni " + svetlo +
              " v cene " + str(ceny_svetel.get(svetlo)) + "Kc.")
        cena += ceny_svetel.get(svetlo)

    print("\n--------------------------------------------------------------------\n")
    print("Celkem bylo vybrano osvetleni v hodnote " + str(cena) + "Kc.")

    input("\nstisknete ENTER pro ukonceni")
