"""
@author Vitaliy Bohera
@version 1
@info Inferenci modul znalostniho systemu pro navrh osvetleni v byte
@date 29.10.2023
"""
import komunikace
import data
from znalosti import vyhody_svitidel, cenik


# Spusteni celeho systemu
def start_system():
    komunikace.uvod_do_systemu()
    vysledek = {}

    for mistnost in data.byt:
        pocet = komunikace.pocet_mistnosti(mistnost)
        for i in range(0, pocet):
            vlastnost = komunikace.vyber_vlatnosti(mistnost, i, data.moznosti_vyberu)

            if mistnost in vysledek:
                vysledek[mistnost+" (" + str(i+1) + ")"] = vyhody_svitidel.get(vlastnost)
            else:
                vysledek[mistnost] = vyhody_svitidel.get(vlastnost)
    cena = spocti_cenu(vysledek)
    komunikace.vypis_vysledek(vysledek, cena)


'''
Funkce spocita celkovou cenu svitidel
@param vysledek - tabulka, kde se kazde mistnosti priradi svitidlo
'''
def spocti_cenu(vysledek):
    cena = 0
    for key, value in vysledek.items():
        cena = cena + int(cenik.get(value))
    return cena
