"""
@author Vitaliy Bohera
@version 1
@info Komunikacni modul znalostniho systemu pro navrh osvetleni v byte
@date 29.10.2023
"""


# vypis hlavicky znalostniho systemu
def uvod_do_systemu():
    print("------------------------------------------")
    print("Znalostní systém pro návrh osvětlení bytu")
    print("------------------------------------------\n")


'''
Funkce se zepta uzivatele na pocet mistnosti daneho typu
@param mistnost - typ mistnosti
@return pocet - pocet mistnosti daneho typu
'''
def pocet_mistnosti(mistnost):
    while True:
        try:
            pocet = int(input("Zadej počet mistnosti typu " + mistnost + ": "))
        except ValueError:
            print("Vstupem musí být číslo!!!\n")
            continue

        if 10 >= pocet >= 0:
            break
        print("Číslo musí být v rozmezi 0 až 10!!!\n")

    return pocet


'''
Funkce vypise jednotlive moznosti vyberu vlastnosti svitidla
@param moznosti_vyberu - seznam vlastnosti
'''
def vypis_moznosti(moznosti_vyberu):
    for i in range(0, len(moznosti_vyberu)):
        print(str(i+1) + " - " + moznosti_vyberu[i])


'''
Funkce se zepta uzivatele na vlastnost svitidla pro danou mistnost
@param mistnost - typ mistnosti
@param index - index mistnosti, pro pripad kdyz je vic mistnosti daneho typu
@param moznosti_vyberu - seznam vlasnosti
@return vybrana vlastnost
'''
def vyber_vlatnosti(mistnost, index, moznosti_vyberu):
    print("Vyberte vlastnost svítidla do " + str(index+1) + ". mistnosti typu " + mistnost + ".")

    vypis_moznosti(moznosti_vyberu)

    while True:
        try:
            vlastnost = int(input("Preferovana vlastnost: "))
        except ValueError:
            print("Vstupem musí být číslo!!!")
            continue

        if 5 >= vlastnost >= 1:
            break
        print("Číslo musí být v rozmezi 1 až 5!!!\n")
    print("------------------------------------------")
    return moznosti_vyberu[vlastnost-1]


'''
Funkce vypise vygenerovany vysledek a take pocet vybranych svititdel a jejich cenu
@param vysledek - tabulka, kde se kazde mistnosti priradi svitidlo
@param cena - celkova cena svitidel
'''
def vypis_vysledek(vysledek, cena):
    print("\nVygenerovaný návrh osvětlení:")
    print("------------------------------------------------------")
    for key, value in vysledek.items():
        print("Do místnosti " + key + " bylo vybráno svítidlo " + value)

    print("\nCelkový počet potřebných světel: " + str(len(vysledek)))
    print("Celková cena svítidel: " + str(cena) + " Kč")
