# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 28. 10. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Modul slouzi ke vzajemne komunikaci ostatnich modulu mezi sebou.
# ------------------------------------------------------------------------------------------------
import baze_dat
import inferencni_modul
import vysvetlovaci_modul


# Funkce vrati vsechna dostupna svetla.
def ziskej_svetla():
    return baze_dat.svetla


# Vrati vsechny definovane mistnosti.
def ziskej_mistnosti():
    return baze_dat.mistnosti


# Necha vysvetlovaci modul, aby ziskal data od uzivatele.
def spust_program():
    vysvetlovaci_modul.ziskej_data_od_uzivatele()


# Prida uzivatelskou preferenci vztahujici se k urcite mistnosti.
def zapis_zavislost_na_preferenci(mistnost, atributy):
    from baze_znalosti import pridej_preferenci
    pridej_preferenci(mistnost, atributy[0], atributy[1], atributy[2], atributy[3], atributy[4])


# Vrati vsechny uzivatelske preference.
def ziskej_preference():
    from baze_znalosti import ziskej_preference
    return ziskej_preference()


# Vrati vsechny obecne znalosti o vztahu mistnosti k vyberu svetla.
def ziskej_zavislosti_na_mistnostech():
    from baze_znalosti import ziskej_zavislosti_na_mistnostech
    return ziskej_zavislosti_na_mistnostech()


# Necha inferencni modul, aby nasel nejvhodnejsi osvetleni
# a predal take duvody sve volby.
def vypocti():
    return inferencni_modul.ziskej_vysledky()


# Ziska jako argument nazev svetla a vraci jeho cenu.
def cena_svetla(svetlo):
    return baze_dat.ziskej_cenu_svetla(svetlo)
