# ------------------------------------------------------------------------------------------------
# Autor: Dominik Vladar
# E-mail: vladar21@students.zcu.cz
# Datum: 28. 10. 2023
# Verze: 1.0
# Prace z predmetu KIV/UZI
# Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved
# ------------------------------------------------------------------------------------------------
# Modul slouzi ke komunikaci s uzivatelem.
# ------------------------------------------------------------------------------------------------
import komunikacni_modul

MAX = 1
MIN = 0
NEZAVISI = -1


# Tato funkce nacte od uzivatele jeho preference k jednotlivym mistnostem, do kterych chce pridat osvetleni.
# Uzivatel muze ke kazde mistnosti pridat vice preferenci. Nevalidni vstupy jsou osetreny.
def ziskej_data_od_uzivatele():
    print("Vitejte ve znalostnim systemu, ktery Vam pomuze s vyberem vhodneho osvetleni pro Vas dum. ")
    print("Program se Vas zepta na nekolik otazek, na ktere muzete odpovedet bud vyberem z nabidky ")
    print("(zadani prislusneho pismena), nebo pokud nabidka chybi, muzete odpovedet ciselnou hodnotou. ")
    print("Pri vyberu z nabidky je mozne vybrat vice moznosti tim, ze pismena zkombinujete ")
    print("(napriklad pokud chcete vybrat moznosti a, b, zadate ab). Take muzete nic nezadat a pouze stisknout Enter.")
    print(" Volbu potvrdte stiskem klavesy ENTER.")
    print("------------------------------------------------------------------------------------------------")
    print("Autor: Dominik Vladar")
    print("Verze: 1.0")
    print("Datum: 28.10.2023")
    print("Predmet: KIV/UZI")
    print("Zapadoceska univerzita v Plzni, Fakulta aplikovanych ved")
    mistnosti = komunikacni_modul.ziskej_mistnosti()
    # projdeme pres vsechny mistnosti a u kazde se zeptame na preference
    for mistnost in mistnosti:
        validni_vstup = False
        # dokud uzivatel nezada validni vstup, budeme se ho ptat porad dokola
        while not validni_vstup:
            try:
                print("------------------------------------------------------------------------------------------------")
                vstup = input("Kolik mate v dome mistnosti typu '{}'? ".format(mistnost.nazev))
                pocet_mistnosti = int(vstup)
                for i in range(pocet_mistnosti):
                    doplnkovy_text = "e" if (1 < (i+1) < 5) else ""
                    if pocet_mistnosti > 1:
                        doplnkovy_text += " " + str(i+1) + "."
                    print("Jake parametry jsou pro Vas klicove v{} mistnosti typu {}? "
                          .format(doplnkovy_text, mistnost.nazev))
                    print("a) Nizka porizovaci cena.")
                    print("b) Nizke naklady na udrzbu.")
                    print("c) Dlouha zivotnost.")
                    print("d) Zajimavy vzhled.")
                    print("e) Moznost menit barvu osvetleni.")
                    vstup = input()
                    validni_vstup2 = False
                    # do atributu pozdeji ulozime jednotlive preference
                    atributy = [NEZAVISI, NEZAVISI, NEZAVISI, NEZAVISI, NEZAVISI]
                    while not validni_vstup2:
                        for pismeno in vstup:
                            match pismeno:
                                case "a":
                                    atributy[0] = MIN
                                case "b":
                                    atributy[1] = MIN
                                case "c":
                                    atributy[2] = MAX
                                case "d":
                                    atributy[3] = MAX
                                case "e":
                                    atributy[4] = MAX
                                case _:
                                    atributy = [NEZAVISI, NEZAVISI, NEZAVISI, NEZAVISI, NEZAVISI]
                                    print("Vstup neni validni, prosim, zkuste to znovu.")
                                    vstup = input()
                                    break
                        else:
                            validni_vstup2 = True
                            komunikacni_modul.zapis_zavislost_na_preferenci(mistnost, atributy)

                validni_vstup = True
            except ValueError:
                # pokud je pozadovano cele cislo, ale uzivatel zada cokoliv jineho, je informovan
                print("Zkuste to prosim znovu. Je potreba zadat cele cislo. ")

    print("------------------------------------------------------------------------------------------------")
    print("Program zvazil Vase preference i obecne znalosti o osvetleni a dosel k temto zaverum:")
    vysledky = komunikacni_modul.vypocti()
    vysvetli_vysledky(vysledky)


# Funkce prijme vysledky ziskane od inferencniho modulu
# v podobe tezko citelnych dat a interpretuje je uzivateli.
def vysvetli_vysledky(vysledky):
    pouzita_svetla = {}
    # projdeme vsechny mistnosti zahrnute do vysledku
    for mistnost in vysledky:
        retezec = "Pro mistnost {} program zvolil jako vhodne osvetleni {}. ".format(mistnost[0], mistnost[1])
        # ulozime si pocet jednotlivych svetel (nazev svetla je ulozeny v mistnost[1])
        if mistnost[1] not in pouzita_svetla:
            pouzita_svetla[mistnost[1]] = 1
        else:
            pouzita_svetla[mistnost[1]] += 1
        duvody = []
        # iterujeme pres jednotlive informace o duvodech vedouci k vyberu,
        # ktere jsou ulozeny v mistnost[2]
        for i in range(len(mistnost[2])):
            # prevedeme ciselne informace o duvodech na citelnou podobu
            match mistnost[2][i][0]:
                case 0:
                    duvody.append(" vhodny svetelny tok pro mistnost {}.".format(mistnost[0]))
                case 1:
                    if mistnost[2][i][1] == MIN:
                        if mistnost[0] == "koupelna":
                            duvody.append(" to, ze 'chladne barvy' svetla nezkresluji Vas vzhled v zrcadle.")
                        else:
                            duvody.append(" vyssi koncentrace pri pouziti chladnejsich barev.")
                    else:
                        duvody.append(" vyssi mira relaxace pri pouziti teplejsich tonu osvetleni.")
                case 2:
                    duvody.append(" privetiva cena svitidla.")
                case 3:
                    duvody.append(" nizke naklady na provoz.")
                case 4:
                    duvody.append(" dlouha zivotnost.")
                case 5:
                    if mistnost[2][i][1] == MIN:
                        duvody.append(", ze toto svetlo zbytecne nevynika.")
                    else:
                        duvody.append(" neobvykly vzhled svetla.")
                case 6:
                    if mistnost[2][i][1] == MIN:
                        duvody.append(" to, ze svetlo nepusobi 'party dojmem'.")
                    else:
                        duvody.append(" moznost menit barvu osvetleni.")

        # mame jednotlive duvody, ted je pouze spojime do jedineho retezce
        for i in range(len(duvody)):
            duvod = duvody[i]
            doplnek = "je"
            if duvod == " nizke naklady na provoz.":
                doplnek = "jsou"
            if i == 0:
                if len(duvody) == 1:
                    retezec += "Duvodem {}{} ".format(doplnek, duvod)
                else:
                    retezec += "Jednim z duvodu {}{} ".format(doplnek, duvod)
            else:
                if i % 2 == 1:
                    retezec += "Dalsim duvodem {}{} ".format(doplnek, duvod)
                else:
                    retezec += "Dale jsme zvazili{} ".format(duvod)
        print(retezec)

    print("------------------------------------------------------------------------------------------------")
    print("Celkem program doporucuje nakup techto svitidel:")
    celkem = 0

    # vypiseme informace o vsech pouzitych svitidlech
    for x in pouzita_svetla:
        cena = komunikacni_modul.cena_svetla(x)
        print("{}: {} ks po {} Kc, celkem {} Kc".format(x, pouzita_svetla[x], cena, cena*pouzita_svetla[x]))
        celkem += cena*pouzita_svetla[x]
    print("Celkova cena: {} Kc".format(celkem))
    print("------------------------------------------------------------------------------------------------")
    input("Ukoncete program stiskem klavesy Enter")
